Test case for --copy-unsafe-links, contributed by Vladimír Michl,
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
3a4c683f
MP
21TMP="$scratchdir"
22FROM=${TMP}/from
23TO=${TMP}/to
3a4c683f 24LOG=${TMP}/log
3fedd74b 25RSYNC="$rsync_bin"
3a4c683f 26
2094283b 27# Berkley's nice.
96553aa7 28PATH="$PATH:/usr/ucb"
2094283b 29
3a4c683f
MP
30runtest() {
31 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
32 if eval "$2"
33 then
34 echo "${ECHO_T} done."
35 return 0
36 else
37 echo "${ECHO_T} failed!"
38 return 1
39 fi
3a4c683f
MP
40}
41
42printmsg() {
43 echo "$1"
44}
45
e052b21f 46
6773a779 47rsync_ls_lR() {
dfef3f10
MP
48 find "$@" -print | sort | xargs "$TOOLDIR/tls"
49}
50
51rsync_getgroups() {
52 "$TOOLDIR/getgroups"
57835c00
MP
53}
54
55
e052b21f
MP
56####################
57# Build test directories TO and FROM, with FROM full of files.
58
3a4c683f 59hands_setup() {
501972bf
MP
60 # Clean before creation
61 rm -rf $FROM
62 rm -rf $TO
3d807132
MP
63
64 [ -d $TMP ] || mkdir $TMP
3a4c683f
MP
65 [ -d $FROM ] || mkdir $FROM
66 [ -d $TO ] || mkdir $TO
67
e052b21f
MP
68 # On some BSD systems, the umask affects the mode of created
69 # symlinks, even though the mode apparently has no effect on how
70 # the links behave in the future, and it cannot be changed using
71 # chmod! rsync always sets its umask to 000 so that it can
72 # accurately recreate permissions, but this script is probably run
73 # with a different umask.
74
75 # This causes a little problem that "ls -l" of the two will not be
76 # the same. So, we need to set our umask before doing any creations.
77
3a4c683f
MP
78 # set up test data
79 touch ${FROM}/empty
80 mkdir ${FROM}/emptydir
e8ca5901 81
571a4b26 82 # a hundred lines of text or so
3d807132 83 rsync_ls_lR "${srcdir}" > ${FROM}/filelist
3a4c683f
MP
84
85 # This might fail on systems that don't have -n
86 echo $ECHO_N "This file has no trailing lf$ECHO_C" > ${FROM}/nolf
0154b302 87 umask 0
3a4c683f 88 ln -s nolf ${FROM}/nolf-symlink
4c80c473 89 umask 022
0154b302 90
4c80c473 91 cat $srcdir/*.c > ${FROM}/text
3a4c683f 92 mkdir ${FROM}/dir
4c80c473 93 cp ${FROM}/text ${FROM}/dir
3a4c683f
MP
94 mkdir ${FROM}/dir/subdir
95 mkdir ${FROM}/dir/subdir/subsubdir
96 ls -ltr /etc > ${FROM}/dir/subdir/subsubdir/etc-ltr-list
97 mkdir ${FROM}/dir/subdir/subsubdir2
98 ls -lt /bin > ${FROM}/dir/subdir/subsubdir2/bin-lt-list
7d691654 99
8f98c608
MP
100# echo testing head:
101# ls -lR ${srcdir} | head -10 || echo failed
3a4c683f 102}
3fedd74b
MP
103
104
99cdaff7
MP
105####################
106# Many machines do not have "mkdir -p", so we have to build up long paths.
107# How boring.
108makepath () {
7c1b7890 109 echo " makepath $1"
99cdaff7
MP
110 p="$1"
111 (
112 # Absolut Unix.
113 if echo $p | grep '^/' >/dev/null
114 then
115 cd /
116 fi
117
118 # This will break if $1 contains a space.
119 for c in `echo $p | tr '/' ' '`
120 do
112e7311
MP
121 if [ -d "$c" ] || mkdir "$c"
122 then
123 cd "$c" || return $?
124 else
125 echo "failed to create $c" >&2; return $?
126 fi
99cdaff7
MP
127 done
128 )
129}
130
131
132
3fedd74b
MP
133###########################
134# Run a test (in '$1') then compare directories $2 and $3 to see if
135# there are any difference. If there are, explain them.
136
f494f286
MP
137# So normally basically $1 should be an rsync command, and $2 and $3
138# the source and destination directories. This is only good when you
139# expect to transfer the whole directory exactly as is. If some files
140# should be excluded, you might need to use something else.
141
3fedd74b 142checkit() {
3fedd74b 143 failed=
3fedd74b 144
cf72f204
MP
145 # We can just write everything to stdout/stderr, because the
146 # wrapper hides it unless there is a problem.
147
148 echo "Running: \"$1\""
149 eval "$1"
3fedd74b
MP
150 status=$?
151 if [ $status != 0 ]; then
152 failed="YES";
153 fi
154
cf72f204
MP
155 echo "-------------"
156 echo "check how the files compare with diff:"
157 echo ""
d58e4c27
MP
158 for f in `cd "$2"; find . -type f -print `
159 do
371d1c36 160 diff -c "$2"/"$f" "$3"/"$f" || failed=YES
d58e4c27
MP
161 done
162
cf72f204
MP
163 echo "-------------"
164 echo "check how the directory listings compare with diff:"
165 echo ""
166 ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from
167 ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to
168 diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
3fedd74b 169 if [ -z "${failed}" ] ; then
3fedd74b
MP
170 return 0
171 else
3fedd74b
MP
172 return 1
173 fi
174}
175
863dff51 176
4a7cb3e8 177build_rsyncd_conf() {
d2094cc3
MP
178 # Build an appropriate configuration file
179 conf="$scratchdir/test-rsyncd.conf"
180 echo "building configuration $conf"
181
182 port=2612
183 pidfile="$scratchdir/rsyncd.pid"
184 logfile="$scratchdir/rsyncd.log"
185
186 cat >$conf <<EOF
3aae15ec 187# rsyncd configuration file autogenerated by $0
d2094cc3 188
3aae15ec
MP
189pid file = $pidfile
190use chroot = no
191hosts allow = localhost, 127.0.0.1
192log file = $logfile
d2094cc3 193
98c1b325
MP
194# We don't know if this machine has "nobody" or "nogroup", so use the quasi-canonical
195# values of (uint16_t) -2.
196
197uid = 65534
198gid = 65534
199
2e6c7f45
MP
200[test-from]
201 path = $FROM
3aae15ec 202 read only = yes
d2094cc3 203
2e6c7f45
MP
204[test-to]
205 path = $TO
3aae15ec 206 read only = no
d2094cc3
MP
207EOF
208}
209
210
3cd2af41
MP
211build_symlinks() {
212 fromdir="$scratchdir/from"
213 todir="$scratchdir/to"
214 mkdir "$fromdir"
215 date >"$fromdir/referent"
216 ln -s referent "$fromdir/relative"
217 ln -s "$fromdir/referent" "$fromdir/absolute"
218 ln -s nonexistent "$fromdir/dangling"
1db8b61d 219 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
220}
221
222test_fail() {
223 echo "$@" >&2
224 exit 1
225}
226
a217ad30
MP
227test_skipped() {
228 echo "$@" >&2
7d821932 229 echo "$@" > "$TMP/whyskipped"
a217ad30
MP
230 exit 77
231}
232
be2f866b
MP
233# It failed, but we expected that. don't dump out error logs,
234# because most users won't want to see them. But do leave
235# the working directory around.
236test_xfail() {
237 echo "$@" >&2
238 exit 78
239}
240
d1239eae
MP
241# Determine what shell command will appropriately test for links.
242ln -s foo "$scratchdir/testlink"
243for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
244do
245 for switch in -h -L
246 do
247 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
248 then
249 # how nice
250 TEST_SYMLINK_CMD="$cmd $switch"
251 # i wonder if break 2 is portable?
252 break 2
253 fi
254 done
255done
256
257
258if [ "x$TEST_SYMLINK_CMD" = 'x' ]
259then
260 test_fail "Couldn't determine how to test for symlinks"
261else
262 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
263fi
264
265
d96d3893
MP
266# Test whether something is a link, allowing for shell peculiarities
267is_a_link() {
d1239eae
MP
268 # note the variable contains the first option and therefore is not quoted
269 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
270}
271
77867907
MP
272
273# We need to set the umask to be reproducible. Note also that when we
274# do some daemon tests as root, we will setuid() and therefore the
275# directory has to be writable by the nobody user in some cases. The
276# best thing is probably to explicitly chmod those directories after
277# creation.
278
279umask 022